#pragma once
#include "PoroMediaDialogShare.h"
#include "DirectoryBrowser.h"
#include "RwInput.h"
#include "afxwin.h"

/////////////////////////////////////////////////////////////////////////////
// RW_Dialog.h : header file 
/////////////////////////////////////////////////////////////////////////////

class RW_Dialog : public CDialog, public PoroMediaDialogShare
{
//	DECLARE_DYNAMIC(RW_Dialog)	//y
// Construction
public:
	RW_Dialog(CWnd* pParent = NULL);   // standard constructor
	virtual ~RW_Dialog();

// Dialog Data
	enum { IDD = IDD_RW_DIALOG };

// Overrides
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);

// Implementation
protected:

	// Generated message map functions
	virtual void OnOK();
	virtual void OnCancel();
	virtual BOOL OnInitDialog();

	// General event handlers
	afx_msg void OnBnClickedButtonInputDirectory();
	afx_msg void OnBnClickedButtonWorkDirectory();
	afx_msg void OnCbnSelchangeComboThresholdingMethod();
	afx_msg void OnBnClickedStop();
	afx_msg void OnEnChangeEditWidthSlices();
	afx_msg void OnEnChangeEditEndSlice();
	afx_msg void OnEnChangeEditWidthx();
	afx_msg void OnEnChangeEditEndx();
	afx_msg void OnEnChangeEditWidthy();
	afx_msg void OnEnChangeEditEndy();
	afx_msg void OnEnChangeEditStartSlice();
	afx_msg void OnEnChangeEditStartx();
	afx_msg void OnEnChangeEditStarty();
	afx_msg void OnEnChangeEditManualThreshold();

	DECLARE_MESSAGE_MAP()

public:
	// Variable declarations	//in same order as of GUI
	//parameters
	CEdit field_rw_NUM_SUB_CUBES_cntrl;
	int field_rw_NUM_SUB_CUBES_int;
	CEdit field_rw_SIZE_SUB_CUBES_cntrl;
	float field_rw_SIZE_SUB_CUBES_float;
	CEdit field_rw_SIZE_SUB_CUBES_MICRONS_cntrl;
	float field_rw_SIZE_SUB_CUBES_MICRONS_float;

	CEdit field_rw_DISTANCE_FROM_CENTER_cntrl;
	float field_rw_DISTANCE_FROM_CENTER_float;
	CEdit field_rw_DISTANCE_FROM_CENTER_MICRONS_cntrl;
	float field_rw_DISTANCE_FROM_CENTER_MICRONS_float;

	CEdit field_rw_MAX_NUM_TRACERS_cntrl;
	int field_rw_MAX_NUM_TRACERS_int;
	CEdit field_rw_MAX_DISTANCE_cntrl;
	float field_rw_MAX_DISTANCE_float;
	CEdit field_rw_MAX_DISTANCE_LAMBDA_cntrl;
	float field_rw_MAX_DISTANCE_LAMBDA_float;
	CEdit field_rw_MAX_JUMP_SIZE_cntrl;
	float field_rw_MAX_JUMP_SIZE_float;
	CEdit field_rw_MAX_JUMP_SIZE_LAMBDA_cntrl;
	float field_rw_MAX_JUMP_SIZE_LAMBDA_float;
	CEdit field_rw_DATACOLLECTIONPOINT_INCREMENT_cntrl;
	float field_rw_DATACOLLECTIONPOINT_INCREMENT_float;
	CEdit field_rw_DATACOLLECTIONPOINT_INCREMENT_LAMBDA_cntrl;
	float field_rw_DATACOLLECTIONPOINT_INCREMENT_LAMBDA_float;

	CEdit field_rw_ROD_cntrl;
	float field_rw_ROD_float;
	CEdit field_rw_LAMBDA_cntrl;
	float field_rw_LAMBDA_float;
	CEdit field_rw_LAMBDA_FOR_FIBER_cntrl;
	float field_rw_LAMBDA_FOR_FIBER_float;
	CEdit field_rw_FPT_BOUNDARY_LAYER_LAMBDA_cntrl;
	float field_rw_FPT_BOUNDARY_LAYER_LAMBDA_float;
	CEdit field_rw_FPT_BOUNDARY_LAYER_MICRONS_cntrl;
	float field_rw_FPT_BOUNDARY_LAYER_MICRONS_float;

	//parameters (lower half of GUI)
	//true RW etc
	CButton CHECK_TRUE_RANDOM_WALK;
	CButton CHECK_SUB_ROI_SPHERE;
	CButton CHECK_RW_MIRROR;
	CButton CHECK_RW_MIRROR_INFINITE;
	CEdit field_rw_MAX_DISPLACEMENT_DIAG_cntrl;
	float field_rw_MAX_DISPLACEMENT_DIAG_COEFF_float;

	CButton CHECK_RW_RANDOM_START;
	CEdit field_rw_MIN_DIST_EDGES_PIXEL_cntrl;
	float field_rw_MIN_DIST_EDGES_PIXEL_float;
	CEdit field_rw_MIN_DIST_EDGES_MICRON_cntrl;
	float field_rw_MIN_DIST_EDGES_MICRON_float;

	CButton CHECK_CV;
	CEdit field_rw_CV_NUM_TRACERS_cntrl;
	int field_rw_CV_NUM_TRACERS_int;
	CEdit field_rw_CV_CRITERIA_cntrl;
	float field_rw_CV_CRITERIA_float;
	CEdit field_rw_CV_NEW_DATA_cntrl;
	float field_rw_CV_NEW_DATA_float;

	//results
	CButton CHECK_SAVE_DETAILED_TRACE;
	CButton CHECK_SAVE_RW_RAW_DATA;

	CEdit field_rw_NUM_BUCKETS1_cntrl;
	int field_rw_NUM_BUCKETS1_int;
	CEdit field_rw_PERCENT_MAX_DISTANCE_cntrl;
	float field_rw_PERCENT_MAX_DISTANCE_float;
	CEdit field_rw_NUM_BUCKETS2_cntrl;
	int field_rw_NUM_BUCKETS2_int;
	CEdit field_rw_PERCENT_DENSEST_BUCKET_cntrl;
	float field_rw_PERCENT_DENSEST_BUCKET_float;

	//batch mode
	CButton CHECK_RW_BATCH_MODE;

	//max RAM (in MB)
	CEdit field_rw_MAX_RAM_cntrl;
	float field_rw_MAX_RAM_float;

	//messages
	afx_msg void OnEnChangeEditPixelSize();

	afx_msg void OnEnChangeEditNumSubCubes();
	afx_msg void OnEnChangeEditRod();
	afx_msg void OnEnChangeLambda();
	afx_msg void OnEnChangeLambdaForFiber();
	afx_msg void OnEnChangeEditSizeSubCube();
	afx_msg void OnEnChangeEditSizeSubCubeMicrons();
	afx_msg void OnEnChangeEditDistanceFromCenter();
	afx_msg void OnEnChangeEditDistanceFromCenterMicrons();

	afx_msg void OnEnChangeNumberTracers();
	afx_msg void OnEnChangeEditMaxDistanceMicrons();
	afx_msg void OnEnChangeEditMaxDistanceLambda();
	afx_msg void OnEnChangeEditMaxJumpSizeMicrons();
	afx_msg void OnEnChangeEditMaxJumpSizeLambda();
	afx_msg void OnEnChangeEditDataCollPointIncrementMicrons();
	afx_msg void OnEnChangeEditDataCollPointIncrementLambda();
	afx_msg void OnEnChangeEditFPTBoundaryLayerLambda();
	afx_msg void OnEnChangeEditFPTBoundaryLayerMicrons();

	afx_msg void OnEnChangeEditMIN_DIST_EDGES_PIXEL();
	afx_msg void OnEnChangeEditMIN_DIST_EDGES_MICRON();

	afx_msg void OnBnClickedButton_true_RW_only();
	afx_msg void OnBnClickedButton_mirror();
	afx_msg void OnBnClickedButton_RW_MIRROR_INFINITE();
	afx_msg void OnBnClickedButton_RANDOM_START();
	afx_msg void OnBnClickedButton_CV();
};
